import { ExtractPropTypes } from 'vue';
import { useTheme } from '../../_mixins';
declare type themePropKeys = keyof typeof useTheme.props;
declare type RemoveReadonly<T> = {
    -readonly [key in keyof T]: T[key];
};
export declare type ExtractPublicPropTypes<T> = Omit<Partial<RemoveReadonly<ExtractPropTypes<T>>>, Exclude<themePropKeys, 'themeOverrides'> | Extract<keyof T, `internal${string}`>>;
export declare type ExtractInternalPropTypes<T> = Partial<ExtractPropTypes<T>>;
export {};
