import { TreeNode } from 'treemate';
import { HTMLAttributes, VNode, VNodeChild } from 'vue';
import type { MenuOption, MenuGroupOption, MenuDividerOption, MenuIgnoredOption, MenuRenderOption, MenuNodeProps } from '../../menu/src/interface';
export declare type Key = string | number;
export declare type DropdownOption = MenuOption;
export declare type DropdownGroupOption = MenuGroupOption;
export declare type DropdownDividerOption = MenuDividerOption;
export declare type DropdownRenderOption = MenuRenderOption;
export declare type DropdownMixedOption = DropdownOption | DropdownGroupOption | DropdownDividerOption | DropdownRenderOption;
export declare type DropdownIgnoredOption = MenuIgnoredOption;
export declare type DropdownIntersectionOption = DropdownOption & DropdownGroupOption;
export declare type TmNode = TreeNode<DropdownOption, DropdownGroupOption, DropdownIgnoredOption>;
export declare type OnUpdateValue = <T extends string & number & (string | number)>(value: T, option: DropdownOption) => void;
export declare type OnUpdateKeys = <T extends string[] & number[] & Array<string | number>>(keys: T) => void;
export declare type OnUpdateValueImpl = <T extends string | number | (string | number)>(value: T, option: DropdownOption) => void;
export declare type OnUpdateKeysImpl = <T extends string[] | number[] | Array<string | number>>(keys: T) => void;
export declare type RenderLabelImpl = (option: DropdownMixedOption) => VNodeChild;
export declare type RenderLabel = (option: DropdownIntersectionOption) => VNodeChild;
export declare type RenderIconImpl = (option: DropdownMixedOption) => VNodeChild;
export declare type RenderIcon = (option: DropdownIntersectionOption) => VNodeChild;
export declare type RenderOption = (info: {
    node: VNode;
    option: DropdownOption & DropdownGroupOption;
}) => VNodeChild;
export declare type RenderOptionImpl = (info: {
    node: VNode;
    option: DropdownOption | DropdownGroupOption;
}) => VNodeChild;
export declare type NodeProps = MenuNodeProps;
export declare type DropdownMenuProps = (option: DropdownOption | undefined, options: Array<DropdownOption | DropdownGroupOption>) => HTMLAttributes & Record<string, string | number | undefined>;
