import { TreeMate, TreeNode } from 'treemate';
import { HTMLAttributes, Ref, VNodeChild } from 'vue';
import type { TreeOptionBase, TreeOption } from '../../tree/src/interface';
export declare type TreeSelectOption = Omit<TreeOptionBase, 'checkboxDisabled' | 'isLeaf' | 'children'> & {
    children?: TreeSelectOption[];
    [k: string]: unknown;
};
export declare type TreeSelectTmNode = TreeNode<TreeSelectOption>;
export declare type OnUpdateValue = (value: string & number & (string | number) & string[] & number[] & Array<string | number> & null, option: TreeSelectOption & null & TreeSelectOption[] & Array<TreeSelectOption | null>) => void;
export declare type OnUpdateValueImpl = (value: string | number | (string | number) | string[] | number[] | Array<string | number> | null, option: TreeSelectOption | null | Array<TreeSelectOption | null>) => void;
export declare type Value = string | number | Array<string | number> | null;
export interface TreeSelectInjection {
    pendingNodeKeyRef: Ref<string | number | null>;
    dataTreeMate: Ref<TreeMate<TreeOption>>;
}
export declare const treeSelectInjectionKey: import("vue").InjectionKey<TreeSelectInjection>;
export declare type TreeSelectRenderTag = (props: {
    option: TreeSelectOption;
    handleClose: () => void;
}) => VNodeChild;
export interface TreeSelectRenderProps {
    option: TreeSelectOption;
    checked: boolean;
    selected: boolean;
}
export declare type TreeSelectRenderTreePart = ({ option, checked, selected }: TreeSelectRenderProps) => VNodeChild;
export declare type TreeSelectRenderLabel = TreeSelectRenderTreePart;
export declare type TreeSelectRenderPrefix = TreeSelectRenderTreePart;
export declare type TreeSelectRenderSuffix = TreeSelectRenderTreePart;
export declare type TreeSelectNodeProps = (info: {
    option: TreeSelectOption;
}) => HTMLAttributes & Record<string, unknown>;
